package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.AiChatModelBo;
import org.dromara.system.domain.vo.AiChatModelVo;
import org.dromara.system.domain.AiChatModelDo;
import org.dromara.system.mapper.AiChatModelMapper;
import org.dromara.system.service.IAiChatModelService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 聊天模型Service业务层处理
 *
 * @author Lion Li
 * @date 2025-10-12
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AiChatModelServiceImpl implements IAiChatModelService {

    private final AiChatModelMapper baseMapper;

    /**
     * 查询聊天模型
     *
     * @param id 主键
     * @return 聊天模型
     */
    @Override
    public AiChatModelVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询聊天模型列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 聊天模型分页列表
     */
    @Override
    public TableDataInfo<AiChatModelVo> queryPageList(AiChatModelBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AiChatModelDo> lqw = buildQueryWrapper(bo);
        Page<AiChatModelVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的聊天模型列表
     *
     * @param bo 查询条件
     * @return 聊天模型列表
     */
    @Override
    public List<AiChatModelVo> queryList(AiChatModelBo bo) {
        LambdaQueryWrapper<AiChatModelDo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AiChatModelDo> buildQueryWrapper(AiChatModelBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AiChatModelDo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AiChatModelDo::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getCategory()), AiChatModelDo::getCategory, bo.getCategory());
        lqw.like(StringUtils.isNotBlank(bo.getModelName()), AiChatModelDo::getModelName, bo.getModelName());
        lqw.eq(StringUtils.isNotBlank(bo.getModelDescribe()), AiChatModelDo::getModelDescribe, bo.getModelDescribe());
        lqw.eq(bo.getModelPrice() != null, AiChatModelDo::getModelPrice, bo.getModelPrice());
        lqw.eq(StringUtils.isNotBlank(bo.getModelType()), AiChatModelDo::getModelType, bo.getModelType());
        lqw.eq(StringUtils.isNotBlank(bo.getModelShow()), AiChatModelDo::getModelShow, bo.getModelShow());
        lqw.eq(StringUtils.isNotBlank(bo.getSystemPrompt()), AiChatModelDo::getSystemPrompt, bo.getSystemPrompt());
        lqw.eq(StringUtils.isNotBlank(bo.getApiHost()), AiChatModelDo::getApiHost, bo.getApiHost());
        lqw.eq(StringUtils.isNotBlank(bo.getApiKey()), AiChatModelDo::getApiKey, bo.getApiKey());
        lqw.eq(StringUtils.isNotBlank(bo.getApiUrl()), AiChatModelDo::getApiUrl, bo.getApiUrl());
        return lqw;
    }

    /**
     * 新增聊天模型
     *
     * @param bo 聊天模型
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AiChatModelBo bo) {
        AiChatModelDo add = MapstructUtils.convert(bo, AiChatModelDo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改聊天模型
     *
     * @param bo 聊天模型
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(AiChatModelBo bo) {
        AiChatModelDo update = MapstructUtils.convert(bo, AiChatModelDo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AiChatModelDo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除聊天模型信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
